facette.InjectFacetteDeliciousConnector = function(sandbox) {
	//Used by greasemonkey.js
	sandbox.unsafeWindow.facetteHostUrl = FACETTE_HOST_URL;
	sandbox.unsafeWindow.facetteToolbarVersion = FACETTE_VERSION_STRING;
	
	//Expose GM API for Facette
	sandbox.unsafeWindow.GM_getValue = function(key,callback){
		setTimeout(function(){
			try {
				var value = sandbox.GM_getValue(key);
				var displayedValue = (value && value.length && value.length > 200) ? value.substr(0,200) + "..." : value;
				consoleLog("Greasemonkey is getting '"+key+"': " + displayedValue);
				callback(value);
			}
			catch(error) {
				facette.handleError(error);
			}
		},0);
	}
	sandbox.unsafeWindow.GM_setValue = function(key,value){
		setTimeout(function(){
			try {
				value = (value) ? value : "";
				sandbox.GM_setValue(key,value);
				if( typeof(value) == "undefined" || value == "" ) {
					consoleLog("Greasemonkey is clearing '"+key+"'.");		
				}
				else {
					var displayedValue = (value.length && value.length > 200) ? value.substr(0,200) + "..." : value;
					consoleLog("Greasemonkey is saving '"+key+"': " + displayedValue);
				}	
			}
			catch(e) {
				facette.handleError(e);
			}
		},0);
	}
	sandbox.unsafeWindow.GM_xmlhttpRequest = function(details){
		setTimeout(function(){
			try {
				if(!/https?:\/\/api\.del\.icio\.us\/.?/.test(details.url) && 
					details.url.indexOf(FACETTE_HOST_URL) != 0) {
					throw "GM_xmlhttpRequest to invalid url: " + details.url;
				}
				var logString = "Greasemonkey is requesting information from \"" + details.url + "\"";
				if(details.headers && details.headers['Authorization']) {
					logString += " using credentials.";
				}
				consoleLog(logString);
				sandbox.GM_xmlhttpRequest(details);	
			}
			catch(e) {
				facette.handleError(e);
			}
		},0);
	}
	
	//Import the rest of the script body
	try {
		var greasemonkeyScript = sandbox.unsafeWindow.document.createElement('script');
		greasemonkeyScript.setAttribute('src', FACETTE_STATIC_HOST_URL+'greasemonkey/greasemonkey.js');
		if(sandbox.unsafeWindow.document && sandbox.unsafeWindow.document.body) {
			sandbox.unsafeWindow.document.body.insertBefore(greasemonkeyScript,sandbox.unsafeWindow.document.body.childNodes[0]);
		}	
	}
	catch(ex) {
		setTimeout(function(){
			facette.handleError(ex);
		},0);
	}
	
	//HELPER METHODS ----------------------------------
	var consoleLog = function(arg1) {
		try {
			if( typeof(sandbox.unsafeWindow.console) != "undefined" ) {
				sandbox.unsafeWindow.console.log(arg1);
			}	
		}
		catch(error) {
			//do nothing
		}
	}
}