facette.gmCompiler = {

    isGreasemonkeyable: function(url){
        var scheme = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).extractScheme(url);
        return ((scheme == "http" || scheme == "https" || scheme == "file") &&
        !/hiddenWindow\.html$/.test(url));
    },
    
    contentLoad: function(aEvent){
		var doc = aEvent.originalTarget; // doc is document that triggered "onload" event
		var href = doc.location.href;
		var isIFrame = (doc.defaultView.frameElement) ? true : false;
        var unsafeWin = doc.defaultView;
        if (unsafeWin.wrappedJSObject) 
            unsafeWin = unsafeWin.wrappedJSObject;
        var unsafeLoc = new XPCNativeWrapper(unsafeWin, "location").location;
			            
        if (!isIFrame && facette.gmCompiler.isGreasemonkeyable(href) && SHOULD_FACETTE_SCRIPT_BE_INJECTED(href)) {
			facette.gmCompiler.injectFacette(href, unsafeWin);
        }
    },
    
    injectFacette: function(url, unsafeContentWin){
        try {
            var sandbox, logger, storage, xmlhttpRequester;
            var safeWin = new XPCNativeWrapper(unsafeContentWin);
            
            sandbox = new Components.utils.Sandbox(safeWin);
            
            var storage = new facette.ScriptStorage();
            xmlhttpRequester = new facette.XmlhttpRequester(unsafeContentWin, window);
            
            sandbox.window = safeWin;
            sandbox.document = sandbox.window.document;
            sandbox.unsafeWindow = unsafeContentWin;
            
            // patch missing properties on xpcnw
            sandbox.XPathResult = Components.interfaces.nsIDOMXPathResult;
            
            // add our own APIs
            sandbox.GM_setValue = facette.gmCompiler.hitch(storage, "setValue");
            sandbox.GM_getValue = facette.gmCompiler.hitch(storage, "getValue");
            sandbox.GM_xmlhttpRequest = facette.gmCompiler.hitch(xmlhttpRequester, "contentStartRequest");
            
            //Inject Facette Delicious Connector
            facette.InjectFacetteDeliciousConnector(sandbox);
        } 
        catch (error) {
            facette.handleError(error);
        }
    },
    
    hitch: function(obj, meth){
        try {
            if (!obj[meth]) {
                throw "method '" + meth + "' does not exist on object '" + obj + "'";
            }
            
            var hitchCaller = Components.stack.caller.filename;
            var staticArgs = Array.prototype.splice.call(arguments, 2, arguments.length);
            
            return function(){
                try {
                    // make a copy of staticArgs (don't modify it because it gets reused for
                    // every invocation).
                    var args = staticArgs.concat();
                    
                    // add all the new arguments
                    for (var i = 0; i < arguments.length; i++) {
                        args.push(arguments[i]);
                    }
                    // invoke the original function with the correct this obj and the combined
                    // list of static and dynamic arguments.
                    return obj[meth].apply(obj, args);
                } 
                catch (error) {
                    facette.handleError(error);
                }
            };
        } 
        catch (error) {
            facette.handleError(error);
        }
    },
    
    onLoad: function(){
		var appcontent = window.document.getElementById("appcontent");
        if (appcontent && !appcontent.greased_facette_gmCompiler) {
            appcontent.greased_facette_gmCompiler = true;
        	appcontent.addEventListener("DOMContentLoaded", facette.gmCompiler.contentLoad, false);	
		}
    },
    
    onUnLoad: function(){
        //remove now unnecessary listeners
        window.removeEventListener('load', facette.gmCompiler.onLoad, false);
        window.removeEventListener('unload', facette.gmCompiler.onUnLoad, false);
        window.document.getElementById("appcontent").removeEventListener("DOMContentLoaded", facette.gmCompiler.contentLoad, false);
    },

};

//object gmCompiler
facette.ScriptStorage = function(){
    try {
        this.prefMan = new facette.PrefManager();
    } 
    catch (error) {
        facette.handleError(error);
    }
}

facette.ScriptStorage.prototype.setValue = function(name, val){
    try {
        this.prefMan.setValue(name, val);
    } 
    catch (error) {
        facette.handleError(error);
    }
}
facette.ScriptStorage.prototype.getValue = function(name, defVal){
    try {
        return this.prefMan.getValue(name, defVal);
    } 
    catch (error) {
        facette.handleError(error);
    }
}


window.addEventListener('load', facette.gmCompiler.onLoad, false);
window.addEventListener('unload', facette.gmCompiler.onUnLoad, false);
